SoSFEnum(3)

NAME
SoSFEnum - The SoSFEnum class is a container for an enum value.

SYNOPSIS

#include <Inventor/fields/SoSFEnum.h>

Inherits SoSField.

Inherited by SoSFBitMask.

  Public Member Functions
virtual SoType getTypeId (void) const
virtual void copyFrom (const SoField &field)
const SoSFEnum & operator= (const SoSFEnum &field)
virtual SbBool isSame (const SoField &field) const
int getValue (void) const
void setValue (int newvalue)
int operator= (int newvalue)
int operator== (const SoSFEnum &field) const
int operator!= (const SoSFEnum &field) const
void setValue (const SbName name)
void setEnums (const int num, const int *vals, const SbName *names)
int getNumEnums (void) const
int getEnum (const int idx, SbName &name) const

  Static Public Member Functions
static void * createInstance (void)
static SoType getClassTypeId (void)
static void initClass (void)

  Protected Member Functions
virtual SbBool findEnumValue (const SbName &name, int &val)
virtual SbBool findEnumName (int value, const SbName *&name) const

  Protected Attributes
int value
int numEnums
int * enumValues
SbName * enumNames
SbBool legalValuesSet

  Additional Inherited Members

Detailed Description

The SoSFEnum class is a container for an enum value. This field is used where nodes, engines or other field containers needs to store one particular value out of an enumerated set.

A field of this type stores its value to file as the symbolic name, rather than the actual integer value.

SoSFEnum instances are initialized on an instance basis, usually in the constructor of the field container with the macros SO_NODE_DEFINE_ENUM_VALUE(enumtype, symbolvalue) and SO_NODE_SET_SF_ENUM_TYPE(enumfield, enumtype) for nodes, or for engines; SO_ENGINE_DEFINE_ENUM_VALUE() and SO_ENGINE_SET_SF_ENUM_TYPE().

Example initialization from the constructor of the SoCone class:

SO_NODE_DEFINE_ENUM_VALUE(Part, SIDES);
SO_NODE_DEFINE_ENUM_VALUE(Part, BOTTOM);
SO_NODE_DEFINE_ENUM_VALUE(Part, ALL);
SO_NODE_SET_SF_ENUM_TYPE(parts, Part);

See also
    SoMFEnum, SoSFBitMask

Member Function Documentation

  void * SoSFEnum::createInstance (void) [static]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Creates a new instance of the class type corresponding to the SoType object.

  SoType SoSFEnum::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoSFEnum::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoField. This is used for runtime type checking and 'downward' casting.

Implements SoField.

Reimplemented in SoSFBitMask.

  void SoSFEnum::copyFrom (const SoField & f) [virtual]
Copy value(s) from f into this field. f must be of the same type as this field.

Implements SoField.

Reimplemented in SoSFBitMask.

  SbBool SoSFEnum::isSame (const SoField & f) const [virtual]
Check for equal type and value(s).

Implements SoField.

Reimplemented in SoSFBitMask.

  void SoSFEnum::initClass (void) [static]
Internal method called upon initialization of the library (from SoDB::init()) to set up the type system.

  void SoSFEnum::setValue (const SbName name)
Set the value of this field by specifying an enumeration string value.

  void SoSFEnum::setEnums (const int num, const int * vals, const SbName * names)
Makes a set of num enumeration names map to integer values, given by vals.

  int SoSFEnum::getNumEnums (void) const
Returns the number of enum names the SoSFEnum object understands.

Note that this API method is not part of the original SGI Inventor 2.1 API, and is an extension specific to Coin.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Since
    Coin 2.0

  int SoSFEnum::getEnum (const int idx, SbName & name) const
Returns the value of the Nth enum this SoSFEnum object understands, and mutates name to contain the Nth enum's name.

Note that this API method is not part of the original SGI Inventor 2.1 API, and is an extension specific to Coin.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Since
    Coin 2.0

  SbBool SoSFEnum::findEnumValue (const SbName & name, int & val) [protected], [virtual]
Return in val the enumeration value which matches the given enumeration name.

Returns TRUE if name is a valid enumeration string, otherwise FALSE.

  SbBool SoSFEnum::findEnumName (int valuearg, const SbName *& name) const [protected], [virtual]
Set the enumeration name which matches the given enumeration value.

Returns TRUE if value is a valid enumeration value, otherwise FALSE.

Member Data Documentation

  int SoSFEnum::numEnums [protected]
Number of enumeration mappings.

  int * SoSFEnum::enumValues [protected]
Array of enumeration values. Maps 1-to-1 with the enumNames.

  SbName * SoSFEnum::enumNames [protected]
Array of enumeration names. Maps 1-to-1 with the enumValues.

  SbBool SoSFEnum::legalValuesSet [protected]
Is TRUE if a set of enum name-to-value mappings has been set.

Author

Generated automatically by Doxygen for Coin from the source code.